#ifndef _SAXPY_KERNEL_H_
#define _SAXPY_KERNEL_H_

#include <stdio.h>
#include "saxpy.h"

__global__ void
saxpy( float alpha, float* x,unsigned int incx,  float* y, unsigned int incy)
{
    // Block index
    int bx = blockIdx.x;

    // Thread index
    int tx = threadIdx.x;

    int Pos = bx * THREAD_NUM *incx + tx*incy;

    y[Pos] = alpha*x[Pos]+y[Pos];
}

#endif 
